routes/web.php
<?php

use App\Http\Controllers\Pages\ThankYouController;
use App\Models\Order;
use Illuminate\Support\Facades\Route;

Auth::routes();

Route::get('/', [App\Http\Controllers\HomeController::class, 'index'])->name('home');

Route::resource('products', \App\Http\Controllers\ProductsController::class)->only(['show', 'index']);
Route::get('checkout', \App\Http\Controllers\CheckoutController::class)->name('checkout');
Route::get('orders/{vendorOrderId}/thank-you', ThankYouController::class)->name('thankyou');

Route::middleware(['auth'])->group(function() {
    Route::post('wishlist/{product}', [\App\Http\Controllers\WishListController::class, 'add'])->name('wishlist.add');
    Route::delete('wishlist/{product}', [\App\Http\Controllers\WishListController::class, 'remove'])->name('wishlist.remove');

    Route::name('account.')->prefix('account')->group(function() {
        Route::get('/', [App\Http\Controllers\Account\HomeController::class, 'index'])->name('home');
        Route::get('wishlist', App\Http\Controllers\Account\WishListController::class)->name('wishlist');
    });

    Route::get('invoices/{order}', \App\Http\Controllers\InvoicesController::class)->name('invoice');
});

Route::name('cart.')->prefix('cart')->group(function() {
    Route::get('/', [\App\Http\Controllers\CartController::class, 'index'])->name('index');
    Route::post('{product}', [\App\Http\Controllers\CartController::class, 'add'])->name('add');
    Route::delete('/', [\App\Http\Controllers\CartController::class, 'remove'])->name('remove');
    Route::put('{product}/count', [\App\Http\Controllers\CartController::class, 'count'])->name('count');
});

// site.com/admin
Route::name('admin.')->prefix('admin')->middleware('role:admin|moderator')->group(function() {
    Route::get('/', \App\Http\Controllers\Admin\DashboardController::class)->name('dashboard');
    Route::resource('products', \App\Http\Controllers\Admin\ProductsController::class)->except(['show']);
    Route::resource('categories', \App\Http\Controllers\Admin\CategoriesController::class)->except(['show']);
});

Route::name('ajax.')->prefix('ajax')->group(function() {
    Route::group(['auth', 'role:admin|moderator'], function() {
        Route::post('products/{product}/images', \App\Http\Controllers\Ajax\Products\UploadImages::class)->name('product.images.upload');
        Route::delete('images/{image}', \App\Http\Controllers\Ajax\RemoveImageController::class)->name('image.remove');
    });

    Route::prefix('paypal')->name('paypal.')->group(function() {
        Route::post('order', [\App\Http\Controllers\Ajax\Payments\PaypalController::class, 'create'])->name('order.create');
        Route::post('order/{vendorOrderId}/capture', [\App\Http\Controllers\Ajax\Payments\PaypalController::class, 'capture'])->name('order.capture');
    });
});

Route::name('callbacks.')->prefix('callbacks')->group(function() {
    Route::get('telegram', \App\Http\Controllers\Callbacks\JoinTelegramController::class)
        ->middleware(['role:admin'])
        ->name('telegram');
});

resources/views/admin/dashboard.blade.php
@extends('layouts.admin')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col">
                @hasrole('admin')
                @unless(auth()->user()->telegram_id)
                    <h3>Telegram auth</h3>
                    <script async
                            src="https://telegram.org/js/telegram-widget.js?22"
                            data-telegram-login="{{ config('services.telegram-bot-api.bot') }}"
                            data-size="large"
                            data-auth-url="{{ route('callbacks.telegram') }}"
                            data-request-access="write"></script>
                @endunless
                @endhasrole
            </div>
        </div>
    </div>
@endsection

resources/views/admin/navigation.blade.php
<li class="nav-item dropdown">
    <a id="productList" class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
        Products
    </a>

    <div class="dropdown-menu dropdown-menu-end" aria-labelledby="productList">
        <a class="dropdown-item" href="{{ route('admin.products.create') }}">
            Create Product
        </a>
        <a class="dropdown-item" href="{{ route('admin.products.index') }}">
            All Products
        </a>
    </div>
</li>

<li class="nav-item dropdown">
    <a id="categoriesList" class="nav-link dropdown-toggle" href="#" role="button" data-bs-toggle="dropdown" aria-haspopup="true" aria-expanded="false" v-pre>
        Categories
    </a>

    <div class="dropdown-menu dropdown-menu-end" aria-labelledby="categoriesList">
        <a class="dropdown-item" href="{{ route('admin.categories.create') }}">
            Create Category
        </a>
        <a class="dropdown-item" href="{{ route('admin.categories.index') }}">
            All Categories
        </a>
    </div>
</li>